﻿local addOn, ns = ...
local L = ns.L

local lastOpenedMoreInfo = nil

local function ColorName(unit)	
	if ns.db.lootHistory_Units[unit] and ns.db.lootHistory_Units[unit] ~= true then
		local className, classFile, index, colorStr = ns.GetClassInfo( ns.db.lootHistory_Units[unit] )		
		if colorStr then			
			return '|c'..colorStr..unit..'|r'
		end
	end
	return unit
end

do
	local select = select
	local find = string.find
	local table_concat = table.concat
	local strsplit = strsplit
	local format = format
	local match = string.match
	
	local enableWowheadlink = true
	
	local lastText = nil
	
	local C = AleaUI_GUI
	C.LootHelper_infoFrames = {}
	
	local list = {}
	
	local wowheadlink = '|cff505050wowhead.com/item=%s&bonus=%s'
	local wowheadlink_short = '|cff505050wowhead.com/item=%s'
	--[==[
		wod
		itemID:enchant:gem1:gem2:gem3:gem4:suffixID:uniqueID:level:upgradeId:instanceDifficultyID:numBonusIds:bonusId1:bonusid2:...:
		
		legion
		itemID:enchant:gem1:gem2:gem3:gem4:suffixID:uniqueID:level:specializationID:upgradeTypeID:instanceDifficultyID:numBonusIDs[:bonusID1:bonusID2:...][:upgradeValue1:upgradeValue2:...]:relic1NumBonusIDs[:relic1BonusID1:relic1BonusID2:...]:relic2NumBonusIDs[:relic2BonusID1:relic2BonusID2:...]:relic3NumBonusIDs[:relic3BonusID1:relic3BonusID2:...]
	]==]
	local legionPattern = "|Hitem:(%-?%d+):.-:.-:.-:.-:.-:.-:.-:.-:.-:.-:.-:(%d+):(.*)|h%["
	local wodPattern = "|Hitem:(%-?%d+):%d+:%d+:%d+:%d+:%d+:%d+:%d+:%d+:%d+:%d+:%d+:(%d+):(.*)|h%["
	
	local function getNumSpaces(amount)
		local text = ''
		
		for i=1, amount do
			text = text .. ''
		end
		
		return text
	end

	local bonusPatten = {
		'(%d+)',
		'(%d+:%d+)',
		'(%d+:%d+:%d+)',
	}
	
	local linkParser
	
	local function BuiltString(text)	
		local timestamp, data, unit, link, _, _, isTrade = strsplit('\n', text)
		
		local tradeColor = isTrade == 'TRADE' and "FF00FF00" or 'ff808080'
		local itemID, numImp, bonuses, bonusList, itemID2
		
		local _, _, _, _, _, _, _, _, _, texture = GetItemInfo(link)
		local _, _, _, _, textureInstant = GetItemInfoInstant(link);
		
		local textureText = ''
		if texture then		
			textureText = '|T'..texture..':0|t'
		elseif textureInstant then
			textureText = '|T'..textureInstant..':0|t'
		end
		
		if enableWowheadlink then
			itemID, numImp, bonuses = match(link, ns.IsLegion and legionPattern or wodPattern)
			
			numImp = tonumber(numImp or '')
			if bonuses and numImp and bonusPatten[numImp] then
				
				bonusList = match(bonuses, bonusPatten[numImp])
			end
			
			itemID2 = ns.GetItemID(link)

			return '|c'..tradeColor..'['..ns.Histoty_FormatDate(timestamp)..']|r '..ColorName(unit)..' - '..textureText..link..' - '..format((bonusList and wowheadlink or wowheadlink_short), itemID2, bonusList)
		else
	
			return '|c'..tradeColor..'['..ns.Histoty_FormatDate(timestamp)..']|r '..ColorName(unit)..' - '..textureText..link
		end
	end

	function ns.LootHistory_ResetEditBox()
		lastText = ''
		C.LootHelper_infoFrames[1].main.infotext:SetText(lastText)
	end
	
	function ns.LootHistroy_ShowResults(filter)
		wipe(list)
		
		list[#list+1] = ''
		list[#list+1] = '[month/day/year - hours/minutes/seconds] - Player Name - ItemLink - wowhead link'
		list[#list+1] = ''
		
		if filter == 'ALL' then
			for i=#ns.db.lootHistory, max(#ns.db.lootHistory-200, 1), -1 do	--max(#ns.db.lootHistory-100, 1)
				local str = ns.db.lootHistory[i]
				list[#list+1] = BuiltString(str)
			end
		elseif filter == 'LATEST' then
			for i=#ns.db.lootHistory, max(#ns.db.lootHistory-20, 1), -1 do
				local str = ns.db.lootHistory[i]
				list[#list+1] = BuiltString(str)			
			end
		else
			
			local arg1, arg2 = strsplit('\n', filter)
		
			if arg1 and arg2 then
				for i=#ns.db.lootHistory, 1, -1 do
					local timestamp, data, unit, link, boss, zone, isTrade = strsplit('\n', ns.db.lootHistory[i])
					local str = timestamp..'\n'..data..'\n'..unit..'\n'..link..'\n'..boss..'\n'..zone
					
					
				--	print('T', str, arg1, find(str, arg1), arg2, find(str, arg2))
					
					if find(str, arg1) and find(str, arg2) then
						list[#list+1] = BuiltString(str)
					end
				end
			elseif arg1 then
				for i=#ns.db.lootHistory, 1, -1 do
					local timestamp, data, unit, link, boss, zone, isTrade = strsplit('\n', ns.db.lootHistory[i])
					local str = timestamp..'\n'..data..'\n'..unit..'\n'..link..'\n'..boss..'\n'..zone
					
					if find(str, arg1) then
						list[#list+1] = BuiltString(str)
					end
				end
			end
		end
		
		list[#list+1] = ''
		list[#list+1] = ''
		
		lastText = table_concat(list, '\n')
		C.LootHelper_infoFrames[1].main.infotext:SetText(lastText)
	end
	
	local function Update(self, panel, opts)
		
		self.free = false
		self:SetParent(panel)
		self:Show()	
	end
	
	local function UpdateSize(self, panel, opts, parent)	
		if opts.width == 'full' then
			if parent then
				self:SetWidth( parent:GetWidth() - 15)
				self.main:SetWidth( parent:GetWidth() - 15)
			else
				self:SetWidth( panel:GetWidth() - 25)
				self.main:SetWidth( panel:GetWidth() - 25)
			end
		else
			self:SetWidth(520)
			self.main:SetWidth(520)
		end
	end
	
	local function Remove(self)
		self.free = true
		self:Hide()
	end
	
	local function CreateCoreButton(parent)
		local f = CreateFrame("Frame", nil, parent)
		f:SetSize(510, 310)
		f:SetFrameLevel(parent:GetFrameLevel() + 1)
		f.Scroll = CreateFrame("ScrollFrame", addOn.."InfoFramesScrollFrame", f, "UIPanelScrollFrameTemplate")
		f.Scroll:SetFrameLevel(f:GetFrameLevel() - 1)
		
		f.infotext = CreateFrame("EditBox", nil, f) 
		f.infotext:SetFontObject(ChatFontWhite)
		f.infotext:SetFont(ns.default_font, 12)
		f.infotext:SetFrameLevel(parent:GetFrameLevel())
		f.infotext:SetAutoFocus(false)
		f.infotext:SetWidth(800)
		f.infotext:SetHeight(300)	
		f.infotext:SetMultiLine(true)
		f.infotext:SetScript("OnEscapePressed", function(self)
			self:ClearFocus()
		end)
		f.infotext:SetScript('OnTextChanged', function(self, userInput)
			if userInput then				
				self:SetText(lastText)
			end
		end)
		
		f.Scroll:SetScrollChild(f.infotext)
		f.Scroll:SetPoint("TOPRIGHT", f, "TOPRIGHT", 0, -2)
		f.Scroll:SetPoint("TOPLEFT", f, "TOPLEFT", 0, -2)
		f.Scroll:SetPoint("BOTTOM", f, "BOTTOM", 0, 2)
	
		
		f.infotext:SetPoint('TOPLEFT', f.Scroll, "TOPLEFT", 11, 0)
		f.infotext:SetPoint('TOPRIGHT', f.Scroll, "TOPRIGHT", 0, 0)
		f.infotext:SetPoint("BOTTOM", f, "BOTTOM", 0, 2)
		f.infotext:SetHyperlinksEnabled(true)
		f.infotext:SetScript('OnHyperlinkClick', function(self, link, text, button)
			SetItemRef(link, text, button, self);
		end)
		
		
		f.Scroll:SetSize(505, 305)
		f.Scroll:SetHorizontalScroll(-5)
		f.Scroll:SetVerticalScroll(0)
		f.Scroll:EnableMouse(true)
		
		f.infotext:Show()
		f.Scroll:Show()
		f:Show()

		return f
	end

	function C:CreateLootHelper_InfoFrame()
		
		for i=1, #C.LootHelper_infoFrames do
			if C.LootHelper_infoFrames[i] then
				return C.LootHelper_infoFrames[i]
			end
		end
		
		local f = CreateFrame("Frame", nil, UIParent)
		f:SetSize(520, 320)
		f.free = true
		
		f.main = CreateCoreButton(f)
		f.main:ClearAllPoints()
		f.main:SetPoint("TOPLEFT", f, "TOPLEFT", 5, -5)
		f.main:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", -25, 0)
		--[[
		f.bg = f:CreateTexture()
		f.bg:SetAllPoints()
		f.bg:SetTexture(1, 1, 0, 0.4)
		]]
		f.Update = Update
		f.Remove = Remove
		f.UpdateSize = UpdateSize
		
		C.LootHelper_infoFrames[#C.LootHelper_infoFrames+1] = f
		
		return f
	end

	C.prototypes["LootHelper_InfoFrame"] = "CreateLootHelper_InfoFrame"
end



local UpdateLootInfo
local MainFrame


local maxScollItems = 80

local mover = CreateFrame("Frame", nil, UIParent)
--mover:EnableMouse(true)
mover:SetMovable(true)
mover:RegisterForDrag("LeftButton")
mover:SetPoint("CENTER", UIParent, "CENTER", 0,200)
mover:SetSize(328, 28)

mover.bg = mover:CreateTexture()
mover.bg:SetAllPoints()
mover.bg:SetTexture(1,0,0,0.6)
mover:Hide()
mover:SetScript("OnDragStart", function()
	if MainFrame.sticky then return end
	
	ns:StartLootListSideMoving()
end)
mover:SetScript("OnDragStop", function()
	if MainFrame.sticky then return end

	ns:StopLootListSideMoving()
end)
--[[
mover.text = mover:CreateFontString()
mover.text:SetPoint("CENTER", mover, "CENTER", 0,0)
mover.text:SetFont(ns.default_font, 10, 'NONE')
mover.text:SetText('LootRolls Mover')
]]
function ns:StartLootListSideMoving()
	if MainFrame.sticky then return end
	
	mover:StartMoving()
end
function ns:StopLootListSideMoving()
	if MainFrame.sticky then return end
	
	mover:StopMovingOrSizing()	
	local x, y = mover:GetCenter()
	local ux, uy = UIParent:GetCenter()
	ns.db.LootListMover = { floor(x - ux + 0.5),floor(y - uy + 0.5) }
	ns:UpdateLootListSizePosition()
end
function ns:UpdateLootListSizePosition()
	mover:SetPoint("CENTER", UIParent, "CENTER", ns.db.LootListMover[1] or 0, ns.db.LootListMover[2] or 0)
end

MainFrame = CreateFrame('Frame', addOn..'LootListMainFrame', UIParent)
MainFrame:SetFrameStrata('MEDIUM')
MainFrame.sticky = false
MainFrame:SetFrameLevel(15)
MainFrame:SetPoint('TOP', mover, 'BOTTOM', 0, 0)
MainFrame:SetSize(250, 310)
MainFrame.bg = MainFrame:CreateTexture(nil, 'BACKGROUND')
MainFrame.bg:SetAllPoints()
ns.CustomSetTexture(MainFrame.bg, 0,0,0,0.8)
MainFrame.frames = {}
MainFrame:Hide()
MainFrame:EnableMouse(true)
MainFrame:RegisterForDrag("LeftButton")
MainFrame:SetScript("OnDragStart", function() ns:StartLootListSideMoving() end)
MainFrame:SetScript("OnDragStop", function() ns:StopLootListSideMoving() end)

MainFrame.left = MainFrame:CreateTexture(nil, 'OVERLAY')
MainFrame.left:SetPoint('TOPLEFT', MainFrame, 'TOPLEFT', 0, 0)
MainFrame.left:SetPoint('BOTTOMLEFT', MainFrame, 'BOTTOMLEFT', 0, 0)
MainFrame.left:SetSize(1,1)
ns.CustomSetTexture(MainFrame.left, 0,0,0,1)

MainFrame.right = MainFrame:CreateTexture(nil, 'OVERLAY')
MainFrame.right:SetPoint('TOPRIGHT', MainFrame, 'TOPRIGHT', 0, 0)
MainFrame.right:SetPoint('BOTTOMRIGHT', MainFrame, 'BOTTOMRIGHT', 0, 0)
MainFrame.right:SetSize(1,1)
ns.CustomSetTexture(MainFrame.right, 0,0,0,1)

MainFrame.bottom = MainFrame:CreateTexture(nil, 'OVERLAY')
MainFrame.bottom:SetPoint('BOTTOMLEFT', MainFrame, 'BOTTOMLEFT', 0, 0)
MainFrame.bottom:SetPoint('BOTTOMRIGHT', MainFrame, 'BOTTOMRIGHT', 0, 0)
MainFrame.bottom:SetSize(1,1)
ns.CustomSetTexture(MainFrame.bottom, 0,0,0,1)

MainFrame.top = MainFrame:CreateTexture(nil, 'OVERLAY')
MainFrame.top:SetPoint('TOPLEFT', MainFrame, 'TOPLEFT', 0, 0)
MainFrame.top:SetPoint('TOPRIGHT', MainFrame, 'TOPRIGHT', 0, 0)
MainFrame.top:SetSize(1,1)
ns.CustomSetTexture(MainFrame.top, 0,0,0,1)

MainFrame.close = CreateFrame("Button", nil, MainFrame, 'UIPanelCloseButton')
MainFrame.close:SetFrameLevel(MainFrame:GetFrameLevel()+5)
MainFrame.close:SetSize(32, 32)	
MainFrame.close:SetPoint("TOPRIGHT", MainFrame, "TOPRIGHT", 3, 3)	

MainFrame.close:SetScript("OnClick", function() 
	MainFrame:Hide()
	
	ns.Histoty_MoreInfoHide()
end)

MainFrame.tempFrom = 1
MainFrame:SetScript("OnMouseWheel", function(self, delta)
	
	self.tempFrom = self.tempFrom - delta

	if self.tempFrom < 1 then
		self.tempFrom = 1
	end
	
	local numHistory = min(#ns.db.lootHistory, maxScollItems)
	
	local minFrom = numHistory - 4
	
	if minFrom < 1 then
		minFrom = 1
	end
	
	if self.tempFrom > minFrom then
		self.tempFrom = minFrom
	end
	
	UpdateLootInfo(self.tempFrom)
	self.sliderIndicator:SetPosition(self.tempFrom, numHistory)
end)

MainFrame.sliderIndicator = MainFrame:CreateTexture(nil, 'OVERLAY')
MainFrame.sliderIndicator:SetSize(2, 100)
ns.CustomSetTexture(MainFrame.sliderIndicator, 0.5,0.5,0.5,1)
MainFrame.sliderIndicator:SetPoint('TOPRIGHT', MainFrame, 'TOPRIGHT', -2, -1)
MainFrame.sliderIndicator.SetPosition = function(self, from, maxV)		
	if maxV <= 5 then
		self:Hide()		
	else
		self:Show()
		local total = 5*(56)
		self:SetHeight(5/maxV*total)
		self:SetPoint("TOPRIGHT", MainFrame, "TOPRIGHT", -2, -25-(from-1)/maxV*total)
	end
end

local function UpdateViewButtonVisability()	
	for i=1, 5 do
		if ns.History_MoreInfoIsShown() then
			if ns.History_IsOpenedMoreInfo(MainFrame.frames[i].view.moreInfo) then
				MainFrame.frames[i].view:SetAlpha(1)
				MainFrame.frames[i].view.texture:SetTexture("Interface\\LFGFrame\\BattlenetWorking1.blp")
			else
				MainFrame.frames[i].view:SetAlpha(0.4)
				MainFrame.frames[i].view.texture:SetTexture("Interface\\LFGFrame\\BattlenetWorking4.blp")
			end
		else
			MainFrame.frames[i].view:SetAlpha(1)
			MainFrame.frames[i].view.texture:SetTexture("Interface\\LFGFrame\\BattlenetWorking4.blp")
		end
	end
end

for i=1, 5 do

	local f = CreateFrame('Frame', nil, MainFrame)
--	f:SetFrameStrata('MEDIUM')
--	f:SetFrameLevel(MainFrame:GetFrameLevel()+1)
	f:SetSize(240, 54)

	f.icon = f:CreateTexture(nil, 'OVERLAY', nil, 2)
	f.icon:SetSize(44, 44)
	f.icon:SetPoint('LEFT', f, 'LEFT', 5, 0)
	ns.CustomSetTexture(f.icon, 1,1,1,1)
	f.icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
	
	f.RelicBorder = f:CreateTexture()
	f.RelicBorder:SetDrawLayer('OVERLAY', 3)
	f.RelicBorder:SetSize(44, 44)
	f.RelicBorder:SetPoint('CENTER', f.icon, 'CENTER', 0, 0)
	f.RelicBorder:SetTexCoord(0.04, 0.96, 0.04, 0.96)
	f.RelicBorder:SetTexture([[Interface\Artifacts\RelicIconFrame]]);
	f.RelicBorder:SetVertexColor(0.7, 0.7, 0.7, 1)

	f.icon.bg = f:CreateTexture(nil, 'OVERLAY', nil, 0)
	f.icon.bg:SetPoint('TOPLEFT', f.icon, 'TOPLEFT', -1, 1)
	f.icon.bg:SetPoint('BOTTOMRIGHT', f.icon, 'BOTTOMRIGHT', 1, -1)
	ns.CustomSetTexture(f.icon.bg, 0,0,0,1)
	
	f.iconOverlay = CreateFrame("Button", nil, f)
--	f.iconOverlay:SetFrameStrata('MEDIUM')
--	f.iconOverlay:SetFrameLevel(f:GetFrameLevel()+1)
	f.iconOverlay:SetAllPoints(f.icon)
	f.iconOverlay:SetSize(44, 44)
	f.iconOverlay:SetScript('OnEnter', ns.SetItemTip)
	f.iconOverlay:SetScript("OnLeave", ns.HideTip2)
	f.iconOverlay:SetScript('OnEvent', ns.SetItemTip)	
	f.iconOverlay:SetScript("OnClick", ns.LootClick)	

	f.text = f:CreateFontString(nil, 'ARTWORK')
	f.text:SetFont(ns.default_font, ns.default_font_size, 'NONE')
	f.text:SetShadowColor(0,0,0,1)
	f.text:SetShadowOffset(1,-1)
	f.text:SetText('Text 1, Text 1, Text 1, Text 1, Text 1, Text 1')
	f.text:SetSize(190, 16)
	f.text:SetJustifyH('LEFT')
	f.text:SetPoint('TOPLEFT', f.icon, 'TOPRIGHT', 4, 2)
	
	f.text2 = f:CreateFontString(nil, 'ARTWORK')
	f.text2:SetFont(ns.default_font, ns.default_font_size, 'NONE')
	f.text2:SetShadowColor(0,0,0,1)
	f.text2:SetShadowOffset(1,-1)
	f.text2:SetText('Text 2, Text 2, Text 2, Text 2, Text 2, Text 2')
	f.text2:SetSize(190, 16)
	f.text2:SetJustifyH('LEFT')
	f.text2:SetPoint('TOPLEFT', f.icon, 'TOPRIGHT', 4, -14)
	
	f.text3 = f:CreateFontString(nil, 'ARTWORK')
	f.text3:SetFont(ns.default_font, ns.default_font_size, 'NONE')
	f.text3:SetShadowColor(0,0,0,1)
	f.text3:SetShadowOffset(1,-1)
	f.text3:SetText('Text 3, Text 3, Text 3, Text 3, Text 3, Text 3')
	f.text3:SetSize(190, 16)
	f.text3:SetJustifyH('LEFT')
	f.text3:SetPoint('TOPLEFT', f.icon, 'TOPRIGHT', 4, -30)
	
	f.bg = f:CreateTexture(nil, 'BACKGROUND')
	f.bg:SetAllPoints()
	ns.CustomSetTexture(f.bg, 0.2,0.2,0.2,0.8)
	
	f.left = f:CreateTexture(nil, 'OVERLAY')
	f.left:SetPoint('TOPLEFT', f, 'TOPLEFT', 0, 0)
	f.left:SetPoint('BOTTOMLEFT', f, 'BOTTOMLEFT', 0, 0)
	f.left:SetSize(1,1)
	ns.CustomSetTexture(f.left, 0,0,0,1)
	
	f.right = f:CreateTexture(nil, 'OVERLAY')
	f.right:SetPoint('TOPRIGHT', f, 'TOPRIGHT', 0, 0)
	f.right:SetPoint('BOTTOMRIGHT', f, 'BOTTOMRIGHT', 0, 0)
	f.right:SetSize(1,1)
	ns.CustomSetTexture(f.right, 0,0,0,1)
	
	f.bottom = f:CreateTexture(nil, 'OVERLAY')
	f.bottom:SetPoint('BOTTOMLEFT', f, 'BOTTOMLEFT', 0, 0)
	f.bottom:SetPoint('BOTTOMRIGHT', f, 'BOTTOMRIGHT', 0, 0)
	f.bottom:SetSize(1,1)
	ns.CustomSetTexture(f.bottom, 0,0,0,1)
	
	f.top = f:CreateTexture(nil, 'OVERLAY')
	f.top:SetPoint('TOPLEFT', f, 'TOPLEFT', 0, 0)
	f.top:SetPoint('TOPRIGHT', f, 'TOPRIGHT', 0, 0)
	f.top:SetSize(1,1)
	ns.CustomSetTexture(f.top, 0,0,0,1)
	
	f:SetPoint('TOP', MainFrame, 'TOP', 0, -25 - (56 * (i-1)))
	
	f.shine = f:CreateTexture(nil, 'OVERLAY', nil, 1)
	f.shine:SetAllPoints(f)
	ns.CustomSetTexture(f.shine, 1, 1, 0, 0.5)
	f.shine:SetAlpha(0)
	
	local ag = f.shine:CreateAnimationGroup()
	local a1 = ag:CreateAnimation("Alpha")
	if ns.IsLegion then
		a1:SetFromAlpha(0)
		a1:SetToAlpha(0.6)
		a1:SetDuration(0.3)
		a1:SetOrder(1)
	else
		a1:SetChange(0.6)
		a1:SetDuration(0.3)
		a1:SetOrder(1)
	end

	local a2 = ag:CreateAnimation("Alpha")
	if ns.IsLegion then
		a2:SetFromAlpha(0.6)
		a2:SetToAlpha(0)
		a2:SetDuration(0.5)
		a2:SetOrder(2)
	else
		a2:SetChange(-0.6)
		a2:SetDuration(0.5)
		a2:SetOrder(2)
	end
	
	f.shine.ag = ag
	
	f.Shine = function(self)
	--	print('Shine icon #'..i)
		self.shine.ag:Play()
	end
	
	
	local view = CreateFrame("BUTTON", nil, f);
    f.view = view;
    view:SetWidth(22);
    view:SetHeight(22);
    view:SetPoint("TOPRIGHT", f, "TOPRIGHT", -2, 0);
	view:SetScript('OnClick', function(self)
	--	print('ns.History_MoreInfoShow')
		
		ns.History_MoreInfoShow(self)
	end)
	view:EnableMouse(true)
	view:RegisterForClicks("RightButtonUp", 'LeftButtonUp')
	
    local viewTexture = view:CreateTexture()
    view.texture = viewTexture;
    viewTexture:SetTexture("Interface\\LFGFrame\\BattlenetWorking1.blp");
    viewTexture:SetTexCoord(0.1, 0.9, 0.1, 0.9);
    viewTexture:SetAllPoints(view);
    view:SetNormalTexture(viewTexture);
    view:SetHighlightTexture("Interface\\LFGFrame\\BattlenetWorking0.blp");

	MainFrame.frames[i] = f
end

local lastFromMaxItem = -1
				
function UpdateLootInfo(from)
--	print('T', 'UpdateLootInfo', from, #ns.db.lootHistory)
	
	from = from - 1
	local index = 0
	local maxNum = #ns.db.lootHistory
--	print('T2', 'from', #ns.db.lootHistory-from, ' - to', #ns.db.lootHistory-4-from)

	if maxNum > 0 then
		for i=maxNum-from, maxNum-4-from, -1 do
			if ns.db.lootHistory[i] then
				index = index + 1
				
			--	print('T3', index)
				
				local timestamp, data, unit, link, bossID, intanceID, buttonName, rollAmount, moreInfo  = strsplit('\n', ns.db.lootHistory[i])
				local buttonName2, rollAmount2
			
				if buttonName and not rollAmount then		
					if string.find(buttonName, UNKNOWN) then
						buttonName = 'Пас'
						rollAmount = 0
					elseif string.find(buttonName, 'TRADE') then
						buttonName = L['TRADE']
						rollAmount = 0
					else
						buttonName2, rollAmount2 = string.match(buttonName, '(.-)(%d+)') --strsplit('\124', buttonName)			
						if buttonName2 and rollAmount2 then
							buttonName = buttonName2
							rollAmount = tonumber(rollAmount)
							
							if string.find(buttonName2, UNKNOWN) then
								buttonName = 'Пас'
								rollAmount = 0
							elseif string.find(buttonName2, 'TRADE') then
								buttonName = L['TRADE']
								rollAmount = 0
							end
						end
					end
				else
					if string.find(buttonName, UNKNOWN) then
						buttonName = ''
						rollAmount = 0
					elseif string.find(buttonName, 'TRADE') then
						buttonName = L['TRADE']
						rollAmount = 0
					end
				end
			
				MainFrame.frames[index].view:Hide()
				MainFrame.frames[index].view.moreInfo = nil
				
				if moreInfo and moreInfo ~= 'NO' and moreInfo ~= '' then
					-- name, rollName, item1, item2, item3

					local moreInfoT = { strsplit('\031', moreInfo) }
					
					if #moreInfoT > 1 then
						--[==[
						local line = 1
						for i=1, floor((#moreInfoT-1)/5) do
							
							print(i, 'a1:', moreInfoT[line], 'a2:', moreInfoT[line+1], 'a3:', moreInfoT[line+2], 'a4:', moreInfoT[line+3], 'a5:', moreInfoT[line+4])
							line = line + 5
							
						end
						]==]
						MainFrame.frames[index].view:Show()
						MainFrame.frames[index].view.moreInfo = moreInfo
					end
					
					wipe(moreInfoT)
				end
				
				local name, _, _, _, _, _, _, _, _, texture = GetItemInfo(link)
				local _, _, _, _, textureInstant = GetItemInfoInstant(link);
				
				local rollText = ''
				if rollAmount and tonumber(rollAmount) and tonumber(rollAmount) > 0 then			
					rollText = '('..rollAmount..')'
				end
				
			--	print('T3', index, ns.Histoty_FormatDate(timestamp), ColorName(unit), buttonName, rollAmount)
			
				if link and IsArtifactRelicItem(link) then
					MainFrame.frames[index].RelicBorder:Show()
				else
					MainFrame.frames[index].RelicBorder:Hide()
				end
		
				MainFrame.frames[index].iconOverlay.link = link
				
				MainFrame.frames[index].text:SetText(ColorName(unit))
				
				local _, _, bossName, instanceName = ns.Cache_GetBossInfoByID(tonumber(string.match(bossID, 'boss:(%d+)')))
				
				MainFrame.frames[index].text2:SetText( bossName or link)
				MainFrame.frames[index].text3:SetText('|cff808080'..ns.Histoty_FormatDate(timestamp)..'|r '..buttonName..rollText)
				MainFrame.frames[index].icon:SetTexture(texture or textureInstant)
				MainFrame.frames[index]:Show()
				
				if lastFromMaxItem ~= -1 then
					if i > lastFromMaxItem then
						MainFrame.frames[index]:Shine()
					end
				end
			end
		end
	end
	lastFromMaxItem = maxNum
	
	for i=index+1, 5 do
		MainFrame.frames[i]:Hide()
	end
	
	UpdateViewButtonVisability()
end

function ns.LootList_ResetLastFromMaxItem()
	if lastFromMaxItem == -1 then return end
	lastFromMaxItem = #ns.db.lootHistory
end

function ns.LootList_ResetPosition()

	if not MainFrame:IsShown() then
		return
	end
	
	local numHistory = min(#ns.db.lootHistory, maxScollItems)
	
	MainFrame.tempFrom = 1

	UpdateLootInfo(MainFrame.tempFrom)
	MainFrame.sliderIndicator:SetPosition(MainFrame.tempFrom, numHistory)
end

function ns.ToggleLootListFrame()	
	if MainFrame:IsShown() then
		ns.HideLootListFrame()
	else
		ns.ShowLootListFrame()
	end
end

function ns.ShowLootListFrame()
	MainFrame:Show()
	ns.ResetLootListFramePosition()
	ns.LootList_ResetPosition()
end


function ns.ShowLootListFrame_Alone()
	if ns.LootRollsMainFrame:IsShown() then
		return
	end
	
	if AleaUI_GUI:IsOpened(addOn) then
		AleaUI_GUI:Close(addOn)
	end
	
	MainFrame:Show()
	MainFrame:SetParent(UIParent)
	MainFrame:ClearAllPoints()
	
	MainFrame:SetPoint('TOP', mover, 'BOTTOM', 0, 0)
	
	MainFrame.sticky = false
	
	ns.LootList_ResetPosition()
end


function ns.ResetLootListFramePosition()
	MainFrame.sticky = true
	MainFrame:SetParent(ns.LootRollsMainFrame.lootHistory.Handler)
	MainFrame:ClearAllPoints()
	MainFrame:SetPoint('TOPLEFT', ns.LootRollsMainFrame, 'TOPRIGHT', 2, 0)
end

function ns.HideLootListFrame()
	MainFrame:Hide()	
	MainFrame.sticky = false
	
	ns.Histoty_MoreInfoHide()
end

--[==[
do
	local select = select
	local find = string.find
	local table_concat = table.concat
	local strsplit = strsplit
	local format = format
	local match = string.match

	local lastText = nil
	
	local C = AleaUI_GUI
	C.LootHelper_infoFramesHistory = {}
	
	local function Update(self, panel, opts)		
		self.free = false
		self:SetParent(panel)
		self:Show()	
	end

	local function Remove(self)
		self.free = true
		self:Hide()
	end
	
	local function OnMainFrameSizeChanged(self, width, height)
	
		print('T', width, height)
	end
	
	local function CreateCoreButton(parent)
		local f = CreateFrame("Frame", nil, parent)
		f:SetSize(510, 310)
		f:SetFrameLevel(parent:GetFrameLevel() + 1)
		f:SetScript('OnSizeChanged', OnMainFrameSizeChanged)
		
		f:Show()

		return f
	end

	function C:CreateLootHelper_InfoFrameHistory()
		
		for i=1, #C.LootHelper_infoFramesHistory do
			if C.LootHelper_infoFramesHistory[i] then
				return C.LootHelper_infoFramesHistory[i]
			end
		end
		
		local f = CreateFrame("Frame", nil, UIParent)
		f:SetSize(520, 320)
		f.free = true
		
		f.main = CreateCoreButton(f)
		f.main:ClearAllPoints()
		f.main:SetPoint("TOPLEFT", f, "TOPLEFT", 5, -5)
		f.main:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", -25, 0)
		
		f.bg = f:CreateTexture()
		f.bg:SetAllPoints()
		f.bg:SetColorTexture(1, 1, 0, 0.4)
		
		f.Update = Update
		f.Remove = Remove

		C.LootHelper_infoFramesHistory[#C.LootHelper_infoFramesHistory+1] = f
		
		return f
	end

	C.prototypes["LootHelper_InfoFrame_History"] = "CreateLootHelper_InfoFrameHistory"
end
]==]


local moreInfoFrame = CreateFrame('Frame', nil, MainFrame)
moreInfoFrame:SetSize(230, 200)
moreInfoFrame:SetPoint('TOPLEFT', MainFrame, 'TOPRIGHT', 2, 0)

moreInfoFrame.left = moreInfoFrame:CreateTexture(nil, 'OVERLAY')
moreInfoFrame.left:SetPoint('TOPLEFT', moreInfoFrame, 'TOPLEFT', 0, 0)
moreInfoFrame.left:SetPoint('BOTTOMLEFT', moreInfoFrame, 'BOTTOMLEFT', 0, 0)
moreInfoFrame.left:SetSize(1,1)
ns.CustomSetTexture(moreInfoFrame.left, 0,0,0,1)

moreInfoFrame.right = moreInfoFrame:CreateTexture(nil, 'OVERLAY')
moreInfoFrame.right:SetPoint('TOPRIGHT', moreInfoFrame, 'TOPRIGHT', 0, 0)
moreInfoFrame.right:SetPoint('BOTTOMRIGHT', moreInfoFrame, 'BOTTOMRIGHT', 0, 0)
moreInfoFrame.right:SetSize(1,1)
ns.CustomSetTexture(moreInfoFrame.right, 0,0,0,1)

moreInfoFrame.bottom = moreInfoFrame:CreateTexture(nil, 'OVERLAY')
moreInfoFrame.bottom:SetPoint('BOTTOMLEFT', moreInfoFrame, 'BOTTOMLEFT', 0, 0)
moreInfoFrame.bottom:SetPoint('BOTTOMRIGHT', moreInfoFrame, 'BOTTOMRIGHT', 0, 0)
moreInfoFrame.bottom:SetSize(1,1)
ns.CustomSetTexture(moreInfoFrame.bottom, 0,0,0,1)

moreInfoFrame.top = moreInfoFrame:CreateTexture(nil, 'OVERLAY')
moreInfoFrame.top:SetPoint('TOPLEFT', moreInfoFrame, 'TOPLEFT', 0, 0)
moreInfoFrame.top:SetPoint('TOPRIGHT', moreInfoFrame, 'TOPRIGHT', 0, 0)
moreInfoFrame.top:SetSize(1,1)
ns.CustomSetTexture(moreInfoFrame.top, 0,0,0,1)


moreInfoFrame.close = CreateFrame("Button", nil, moreInfoFrame, 'UIPanelCloseButton')
moreInfoFrame.close:SetFrameLevel(moreInfoFrame:GetFrameLevel()+5)
moreInfoFrame.close:SetSize(32, 32)	
moreInfoFrame.close:SetPoint("TOPRIGHT", moreInfoFrame, "TOPRIGHT", 3, 3)
moreInfoFrame.close:SetScript('OnClick', function(self)
	ns.Histoty_MoreInfoHide()
end)
moreInfoFrame:Hide()
moreInfoFrame.bg = moreInfoFrame:CreateTexture(nil, 'BACKGROUND')
moreInfoFrame.bg:SetAllPoints()
ns.CustomSetTexture(moreInfoFrame.bg, 0,0,0,0.8)

moreInfoFrame.lines = {}

function ns.History_MoreInfo_CreateLine(index)

	local line = CreateFrame('Frame', nil, moreInfoFrame)
	line:SetSize(moreInfoFrame:GetWidth()-4, 20)
	
	line.bg = line:CreateTexture(nil, 'BACKGROUND')
	line.bg:SetAllPoints()
	ns.CustomSetTexture(line.bg, 0.2,0.2,0.2,0.8)

	line.name = line:CreateFontString()
	line.name:SetFontObject('GameFontWhite')
	line.name:SetDrawLayer('OVERLAY', 2)
	line.name:SetFont(ns.default_font, ns.default_font_size, ns.default_font_outline)
	line.name:SetText('Name')
	line.name:SetSize(80, 20)
	line.name:SetPoint('LEFT', line, 'LEFT', 2, 0)
	line.name:SetShadowColor(0,0,0,1)
	line.name:SetShadowOffset(1,-1)
	line.name:SetJustifyH("LEFT")
	
	line.roll = line:CreateFontString()
	line.roll:SetFontObject('GameFontWhite')
	line.roll:SetDrawLayer('OVERLAY', 2)
	line.roll:SetFont(ns.default_font, ns.default_font_size, ns.default_font_outline)
	line.roll:SetText('Roll')
	line.roll:SetSize(80, 20)
	line.roll:SetPoint('LEFT', line, 'LEFT', 74, 0)
	line.roll:SetShadowColor(0,0,0,1)
	line.roll:SetShadowOffset(1,-1)
	line.roll:SetJustifyH("CENTER")

	line.items1 = CreateFrame("Button", nil, line)
	line.items1:SetPoint("LEFT", line, 'LEFT', moreInfoFrame:GetWidth()-68, 0)
	line.items1:SetSize(14, 14)
	line.items1:SetScript("OnEnter", ns.SetItemTip)
	line.items1:SetScript("OnLeave", ns.HideTip2)
	line.items1:SetScript('OnEvent', ns.SetItemTip)

	line.items1:SetScript("OnClick", ns.LootClick)	
	line.items1.icon = line.items1:CreateTexture(nil, 'OVERLAY')
	line.items1.icon:SetAllPoints()
	line.items1.icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
	line.items1.icon:SetColorTexture(0.5, 0, 0, 1)
	
	line.items2 = CreateFrame("Button", nil, line)
	line.items2:SetPoint("LEFT", line.items1, 'RIGHT', 2, 0)
	line.items2:SetSize(14, 14)
	line.items2:SetScript("OnEnter", ns.SetItemTip)
	line.items2:SetScript("OnLeave", ns.HideTip2)
	line.items2:SetScript('OnEvent', ns.SetItemTip)
	line.items2:SetScript("OnClick", ns.LootClick)	
	line.items2.icon = line.items2:CreateTexture(nil, 'OVERLAY')
	line.items2.icon:SetAllPoints()
	line.items2.icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
	line.items2.icon:SetColorTexture(0.5, 0, 0, 1)
	
	line.items3 = CreateFrame("Button", nil, line)
	line.items3:SetPoint("LEFT", line.items2, 'RIGHT', 2, 0)
	line.items3:SetSize(14, 14)
	line.items3:SetScript("OnEnter", ns.SetItemTip)
	line.items3:SetScript("OnLeave", ns.HideTip2)
	line.items3:SetScript('OnEvent', ns.SetItemTip)
	line.items3:SetScript("OnClick", ns.LootClick)	
	line.items3.icon = line.items3:CreateTexture(nil, 'OVERLAY')
	line.items3.icon:SetAllPoints()
	line.items3.icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
	line.items3.icon:SetColorTexture(0.5, 0, 0, 1)
	
	line.items4 = CreateFrame("Button", nil, line)
	line.items4:SetPoint("LEFT", line.items3, 'RIGHT', 2, 0)
	line.items4:SetSize(14, 14)
	line.items4:SetScript("OnEnter", ns.SetItemTip)
	line.items4:SetScript("OnLeave", ns.HideTip2)
	line.items4:SetScript('OnEvent', ns.SetItemTip)
	line.items4:SetScript("OnClick", ns.LootClick)	
	line.items4.icon = line.items4:CreateTexture(nil, 'OVERLAY')
	line.items4.icon:SetAllPoints()
	line.items4.icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
	line.items4.icon:SetColorTexture(0.5, 0, 0, 1)
	
	line:SetPoint('TOPLEFT', moreInfoFrame, 'TOPLEFT', 2, -26 + (-21 * (index-1) ))
	moreInfoFrame.lines[index] = line
	
	return line
end

function ns.Histoty_MoreInfoHide()
	moreInfoFrame:Hide()
	for i=1, #moreInfoFrame.lines do
		moreInfoFrame.lines[i]:Hide()
	end
	
	lastOpenedMoreInfo = nil
end

function ns.History_IsOpenedMoreInfo(moreInfo)
	return lastOpenedMoreInfo == moreInfo
end

function ns.History_MoreInfoIsShown()	
	return moreInfoFrame:IsShown()
end

function ns.History_MoreInfoShow(button)	
	local moreInfo = button.moreInfo
	
--	print('T', moreInfo)
	local numitems4 = (moreInfo or ''):find('numitems4')
	if numitems4 then
		moreInfo = moreInfo:gsub('numitems4', '')
	end
	
	local moreInfoT = { strsplit('\031', moreInfo or '') }
	
	ns.Histoty_MoreInfoHide()

	if #moreInfoT > 1 then
		
		lastOpenedMoreInfo = button.moreInfo
		
		local line = 1
		for i=1, ceil((#moreInfoT-1)/( numitems4 and 6 or 5 )) do
			
		--	print(i, 'a1:', moreInfoT[line], 'a2:', moreInfoT[line+1], ns.GetItemID(moreInfoT[line+1]), 'a3:', moreInfoT[line+2], ns.GetItemID(moreInfoT[line+2]), 'a4:', moreInfoT[line+3], ns.GetItemID(moreInfoT[line+3]), 'a5:', moreInfoT[line+4], ns.GetItemID(moreInfoT[line+4]))
			
			local lineFrame = moreInfoFrame.lines[i] or ns.History_MoreInfo_CreateLine(i)
			
			lineFrame:Show()
			
			local itemID1 = ( moreInfoT[line+2] and ns.GetItemID(moreInfoT[line+2]))
			local itemID2 = ( moreInfoT[line+3] and ns.GetItemID(moreInfoT[line+3]))
			local itemID3 = ( moreInfoT[line+4] and ns.GetItemID(moreInfoT[line+4]))
			local itemID4 = numitems4 and ( moreInfoT[line+5] and ns.GetItemID(moreInfoT[line+5]))
			
			local textureInstant1 = itemID1 and select(5, GetItemInfoInstant(itemID1));
			local textureInstant2 = itemID2 and select(5, GetItemInfoInstant(itemID2));
			local textureInstant3 = itemID3 and select(5, GetItemInfoInstant(itemID3));
			local textureInstant4 = numitems4 and itemID4 and select(5, GetItemInfoInstant(itemID4));

			lineFrame.name:SetText(moreInfoT[line])
			lineFrame.roll:SetText(moreInfoT[line+1])
			
			if textureInstant1 then
				lineFrame.items1.icon:SetTexture(textureInstant1)
				lineFrame.items1.link = moreInfoT[line+2]
				lineFrame.items1:Show()	
			else
				lineFrame.items1:Hide()	
				lineFrame.items1.link = nil				
			end
			
			if textureInstant2 then
				lineFrame.items2.icon:SetTexture(textureInstant2)
				lineFrame.items2.link = moreInfoT[line+3]
				lineFrame.items2:Show()	
			else
				lineFrame.items2:Hide()	
				lineFrame.items2.link = nil				
			end
			
			if textureInstant3 then
				lineFrame.items3.icon:SetTexture(textureInstant3)
				lineFrame.items3.link = moreInfoT[line+4]
				lineFrame.items3:Show()	
			else
				lineFrame.items3:Hide()	
				lineFrame.items3.link = nil				
			end
			
			if textureInstant4 and numitems4 then
				lineFrame.items4.icon:SetTexture(textureInstant4)
				lineFrame.items4.link = moreInfoT[line+5]
				lineFrame.items4:Show()	
			else
				lineFrame.items4:Hide()	
				lineFrame.items4.link = nil				
			end
			
			moreInfoFrame:SetHeight(28 + (21 * i ))
			moreInfoFrame:Show()
			
			line = line + ( numitems4 and 6 or 5 )
			
			if not moreInfoT[line] then
				break
			end
		end
	end
	
	UpdateViewButtonVisability()
end